#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <libguile.h>

#define MAX_IFACES 32

struct sql_connect {
	int iface;
	char *hostname;
	struct in_addr hostaddr;
	int port;
	char *username;
	char *database;
	void *data;
};

struct sql_result {
	SCM owner;
	void *data;
};

struct sql_iface {
	char *name;
	SCM (*mark) (struct sql_connect *);
	scm_sizet (*free) (struct sql_connect *);
	SCM (*connect) (char *hostname, int port,
			char *dbname, char *user, char *pass, char *why);
	void (*close) (struct sql_connect *);
	SCM (*query) (struct sql_connect *, char *query);
};

extern struct sql_iface sql_iftab[];
